
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/utsname.h>
#include "mpi.h"

main(int argc, char **argv)
{
    int i, j, k;
    char buf2[256], buf[8192], bufb[8192];
    int myid;
    struct utsname ubuf;
    char *cp;

    cp = getenv("MPI_TEST");
    sprintf(bufb, "<%d>", argc);
    for (i = 0; i < argc; i++) {
        sprintf(buf2, "<%d>", i);
        strcat(bufb, buf2);
        strcat(bufb, argv[i]);
    }
    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &myid);
    printf("ENV MPI_TEST%02d%s<>\n", myid, cp);
    printf("F%02d%s<>\n", myid, bufb);
    fflush(stdout);
    MPI_Barrier(MPI_COMM_WORLD);

    sprintf(buf, "<%d>", argc);
    for (i = 0; i < argc; i++) {
        sprintf(buf2, "<%d>", i);
        strcat(buf, buf2);
        strcat(buf, argv[i]);
    }
    printf("B%02d%s<>\n", myid, buf);
    fflush(stdout);
    MPI_Barrier(MPI_COMM_WORLD);
    uname(&ubuf);
    printf("%02d:%s %s %s %s %s \n", myid, 
        ubuf.sysname, ubuf.nodename, ubuf.release, 
        ubuf.version, ubuf.machine);
    fflush(stdout);
    MPI_Barrier(MPI_COMM_WORLD);
    MPI_Finalize();
}
